config/routes.rb
Rails.application.routes.draw do
  resources :collaborations
  mount RailsAdmin::Engine => '/admin', as: 'rails_admin'
  # resources :assignment_submissions
  resources :group_members ,only: [:create,:destroy]
  resources :groups do
    resources :assignments
  end

  scope '/groups' do
    get '/:id/assignments/WYSIWYG/index.css', to: redirect('/index.css')
    get '/:id/assignments/WYSIWYG/bootstrap-wysiwyg.js', to: redirect('/bootstrap-wysiwyg.js')
    get '/:id/assignments/:id/WYSIWYG/index.css', to: redirect('/index.css')      # in case of editing
    get '/:id/assignments/:id/WYSIWYG/bootstrap-wysiwyg.js', to: redirect('/bootstrap-wysiwyg.js')   # in case of editing
    get '/:group_id/assignments/:id/reopen', to: 'assignments#reopen', as: 'reopen_group_assignment'
    get '/:group_id/assignments/:id/start', to: 'assignments#start', as: 'assignment_start'
  end
  resources :stars , only: [:create, :destroy]


  devise_for :users, controllers: {registrations: 'users/registrations', :omniauth_callbacks => "users/omniauth_callbacks"}


  #Logix web pages resources
  root 'logix#index'
  get  '/gettingStarted', to:'logix#gettingStarted'
  get  '/examples', to:'logix#examples'
  get  '/features', to:'logix#features'
  get  '/about', to:'logix#about'
  get  '/privacy', to:'logix#privacy'
  get  '/tos', to:'logix#tos'
  get  '/search', to:'logix#search'
  get  '/teachers', to:'logix#teachers'
  get  '/contribute', to:'logix#contribute'

  #users
  scope '/users' do
    get '/', to: 'welcome#all_user_index', as: 'all_users'
    get '/:id/profile', to: 'users/logix#profile', as: 'profile'
    get '/:id/profile/edit', to: 'users/logix#edit', as: 'profile_edit'
    patch '/:id/update', to: 'users/logix#update', as: 'profile_update'
    get '/:id/groups', to: 'users/logix#groups', as: 'user_groups'
    get '/:id/', to: 'users/logix#index', as: 'user_projects'
    get '/:id/favourites', to: 'users/logix#favourites', as: 'user_favourites'
    get '/:id/projects/:id/WYSIWYG/index.css', to: redirect('/index.css')
    get '/:id/projects/:id/WYSIWYG/bootstrap-wysiwyg.js', to: redirect('/bootstrap-wysiwyg.js')
  end


  #projects
  get 'projects/create_fork/:id', to: 'projects#create_fork',as: 'create_fork_project'
  get 'projects/change_stars/:id', to: 'projects#change_stars', as: 'change_stars'

  mount Commontator::Engine => '/commontator'

  #simulator
  scope '/simulator' do
    get '/:id', to: 'simulator#show', as: 'simulator'
    get '/edit/:id', to: 'simulator#edit', as: 'simulator_edit'
    post '/get_data', to: 'simulator#get_data'
    post '/update_data', to: 'simulator#update'
    post '/update_image', to: 'simulator#update_image'
    post '/create_data', to: 'simulator#create'
    get '/', to: 'simulator#new', as: 'simulator_new'
    get '/embed/:id', to: 'simulator#embed', as: 'simulator_embed'
  end
  # get 'simulator/embed_cross/:id', to: 'simulator#embed_cross', as: 'simulator_embed_cross'


  resources :users do
    resources :projects, only: [:show, :edit, :update, :new, :create, :destroy]
  end




  # get 'comments/create_reply/:id', to: 'comments#create_reply', as: 'reply_comment'
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/project.rb
class Project < ApplicationRecord
  belongs_to :author, class_name: 'User'
  has_many :forks , class_name: 'Project', foreign_key: 'forked_project_id', dependent: :nullify
  belongs_to :forked_project , class_name: 'Project' , optional: true
  has_many :stars , dependent: :destroy
  has_many :user_ratings, through: :stars , dependent: :destroy ,source: 'user'
  belongs_to :assignment , optional: true

  has_many :collaborations, dependent: :destroy
  has_many :collaborators, source: 'user' , through: :collaborations

  mount_uploader :image_preview, ImagePreviewUploader

  self.per_page = 8

  acts_as_commontable
  # after_commit :send_mail, on: :create

  def check_edit_access(user)
    @user_access =
        ((!user.nil? and self.author_id == user.id and self.project_submission != true) \
        or (!user.nil? and Collaboration.find_by(project_id:self.id,user_id:user.id)))

  end

  def check_view_access(user)
    @user_access =
        (self.project_access_type != "Private" \
        or (!user.nil? and self.author_id==user.id) \
        or (!user.nil? and !self.assignment_id.nil? and self.assignment.group.mentor_id==user.id) \
        or (!user.nil? and Collaboration.find_by(project_id:self.id,user_id:user.id)) \
        or (!user.nil? and user.admin))
  end


  def check_direct_view_access(user)
    @user_access =
        (self.project_access_type == "Public" or \
        (self.project_submission == false and  !user.nil? and self.author_id==user.id) or \
        (!user.nil? and Collaboration.find_by(project_id:self.id,user_id:user.id)) or \
        (!user.nil? and user.admin))
  end

  def increase_views(user)

    if user.nil? or user.id != self.author_id
      self.view ||=0
      self.view += 1
      self.save
    end
  end


  def send_mail
    if(self.forked_project_id.nil?)
      if(self.project_submission == false)
        UserMailer.new_project_email(self.author,self).deliver_later
      end
    else
      if(self.project_submission == false)
        UserMailer.forked_project_email(self.author,self.forked_project,self).deliver_later
      end
    end
  end


  validate :check_validity

  private
  def check_validity
    if project_access_type != "Private" and !assignment_id.nil?
      errors.add(:project_access_type, "Assignment has to be private")
    end
  end


end

app/controllers/projects_controller.rb
class ProjectsController < ApplicationController
  before_action :set_project, only: [:show, :edit, :update, :destroy, :create_fork, :change_stars]
  before_action :authenticate_user!, only: [:edit, :update, :destroy, :create_fork, :change_stars]

  before_action :set_access , only: [:show, :edit, :update, :destroy, :create_fork]
  before_action :check_access , only: [:edit, :update, :destroy]
  before_action :check_delete_access , only: [:destroy]
  before_action :check_view_access , only: [:show, :create_fork]

  # GET /projects
  # GET /projects.json
  def index
    @author = User.find(params[:user_id])
  end

  # GET /projects/1
  # GET /projects/1.json
  def show
    @project.increase_views(current_user)
    @collaboration = @project.collaborations.new
    @admin_access = true
    commontator_thread_show(@project)
  end

  # GET /projects/new
  def new
    @project = Project.new
  end

  # GET /projects/1/edit
  def edit
  end

  def change_stars

    star = Star.find_by(user_id: current_user.id, project_id: @project.id)
    if !star.nil?
        star.destroy
        render :js => "1"
    else
      @star = Star.new()
      @star.user_id = current_user.id
      @star.project_id = @project.id
      @star.save
      render :js => "2"
    end

  end


  def create_fork

    # Relaxing fork constraints for now
    # if current_user.id == @project.author_id
    #   render plain: "Cannot fork your own project" and return
    # end

    if !@project.assignment_id.nil?
      render plain: "Cannot fork an assignment" and return
    end

    @project_new = @project.dup
    @project_new.view = 1
    @project_new.remove_image_preview!
    @project_new.author_id = current_user.id
    @project_new.forked_project_id = @project.id
    @project_new.name = @project.name
    @project_new.save

    redirect_to user_project_path(current_user,@project_new)
  end

  # POST /projects
  # POST /projects.json
  def create

    @project = current_user.projects.create(project_params)

    respond_to do |format|
      if @project.save
        format.html { redirect_to user_project_path(current_user,@project), notice: 'Project was successfully created.' }
        format.json { render :show, status: :created, location: @project }
      else
        format.html { render :new }
        format.json { render json: @project.errors, status: :unprocessable_entity }
      end
    end

  end

  # PATCH/PUT /projects/1
  # PATCH/PUT /projects/1.json
  def update
    @project.description = params["description"]
    respond_to do |format|
      if @project.update(project_params)
        format.html { redirect_to user_project_path(current_user,@project) , notice: 'Project was successfully updated.' }
        format.json { render :show, status: :ok, location: @project }
      else
        format.html { render :edit }
        format.json { render json: @project.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /projects/1
  # DELETE /projects/1.json
  def destroy
    @project.destroy
    respond_to do |format|
      format.html { redirect_to user_path(current_user), notice: 'Project was successfully destroyed.' }
      format.json { head :no_content }
    end
  end


  private
    # Use callbacks to share common setup or constraints between actions.
    def set_project
      @project = Project.find(params[:id])
      @author = @project.author
    end

    def set_access
      @user_access = user_signed_in? ? @project.check_edit_access(current_user) : false
      @is_author = @project.author_id == (user_signed_in? and current_user.id)
    end

    def check_access
      if(!@user_access)
        render plain: "Access Restricted" and return
      end
    end

    def check_delete_access
      if(!@is_author)
        render plain: "Access Restricted" and return
      end
    end

    def check_view_access
      if(!@project.check_view_access(current_user))
        render plain: "Access Restricted" and return
      end
    end
    # Never trust parameters from the scary internet, only allow the white list through.
    def project_params
      params.require(:project).permit(:name, :project_access_type, :description)
    end

end

app/helpers/projects_helper.rb
module ProjectsHelper
end

app/views/projects/_form.html.erb
<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.9.0/jquery.min.js"></script>
<%= form_with(model: [ current_user, @project] , local: true, multipart: true, id:"projectForm") do |form| %>
  <% if project.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(project.errors.count, "error") %> prohibited this project from being saved:</h2>

      <ul>
      <% project.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :name %>
    <%= form.text_field :name, id: :project_name %>
  </div>


  <div class="field">
    <%= form.label :project_access_type %>
    <%= form.select :project_access_type, [["Public","Public"],["Private","Private"],["Limited access","Limited access"]], id: :project_project_access_type %>
  </div>

  <div class="field" id="wysiwyg">
    <%= form.label :description %><br>
    <%= render "wysiwyg/index" %>
  </div>


  <div class="actions" , onclick="before_submit()">
    <%= form.submit() %>
  </div>

<% end %>


<script>
  function before_submit(){                     //add params before submission
    $('<input />').attr('type', 'hidden')
        .attr('name', 'description')
        .attr('value', $("#editor").cleanHtml())
        .appendTo('#projectForm');
    }

</script>

app/views/projects/edit.html.erb
<div class="container feature">
  <h1>Editing Project</h1>

  <%= render 'form', project: @project %>

  <%= link_to 'Show', user_project_path(current_user,@project) %> |
  <%= link_to 'Back', user_path(@author)%>

</div>

app/views/projects/new.html.erb
<div class="container feature">
<h1>New Project</h1>

<%= render 'form', project: @project %>

<%= link_to 'Back', user_path(current_user) %>
</div>

app/views/projects/show.html.erb
<% content_for :title, @project.name %>
<% content_for :author_name, @project.author.name %>
<% content_for :page_description, @project.description %>


<!--<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>-->
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
<div class="container feature">
    <% if notice %>
        <div class="row">
            <div class="alert alert-success alert-dismissible container-fluid text-center">
                <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
                <%= notice %>
            </div>
        </div>
    <% end %>
  <div class="row ">

    <div class="col col-7 ">
        <div class="embed-responsive embed-responsive-4by3 feature">
          <iframe src = <%=simulator_path(@project) %> webkitAllowFullScreen mozAllowFullScreen allowFullScreen scrolling="no"> </iframe>
        </div>
    </div>
    <div class="col col-5">

      <div class="card h-100">
        <div class="card-header text-center font-weight-bold text-capitalize">
          <%= @project.name %>  &ensp;  &ensp;  &ensp;  &ensp; &ensp; &ensp; &ensp; &ensp;
          <span class="badge badge-secondary noSelect">
            &ensp;&ensp;
            <% if user_signed_in? %>
                <i id="toggleStarButton" class="fa fa-star fa-2x noSelect" aria-hidden="true" style=<%= Star.find_by(user_id: current_user.id, project_id: @project.id).nil? ? "color:white" : "color:orange" %> onclick="toggleStar()"></i>
                &ensp;
            <% else%>
                <i  class="fa fa-star fa-2x noSelect" aria-hidden="true" style="color:orange" ></i>
                &ensp;
            <% end %>
            <r id="star_count" style="font-size:20px" class="noSelect"><%= @project.stars.count %></r>&ensp;&ensp;&ensp;
            <i class="fa fa-eye fa-2x" aria-hidden="true" style="font-size:24px;font-weight: bold">&ensp;</i>
            <r id="star_count" style="font-size:20px" class="noSelect"><%= @project.view %></r>&ensp;&ensp;&ensp;
            </span>
        </div>
        <ul class="list-group list-group-flush">
          <li class="list-group-item">
            <p class="card-text">
              <strong>Author:</strong>
              <%= link_to @project.author.name, @project.author %>
            </p>

            <% if !@project.forked_project.nil? %>
                <p class="card-text">
                  <strong>Forked project:</strong>
                  <%= link_to @project.forked_project.author.name+"/"+@project.forked_project.name , user_project_path(@project.forked_project.author,@project.forked_project) %>
                </p>
            <% end %>

            <p class="card-text">
              <strong>Project access type:</strong>
              <%= @project.project_access_type %>
            </p>

          </li>
          <li class="list-group-item text-center">
            <a href="#>" class="btn btn-secondary previewButton" id="<%=@project.id%>" data-toggle="modal" data-target="#myModal">Preview</a>
            <% if @user_access %>
                <a href="<%= simulator_edit_path(@project) %>" class="btn btn-primary" target="_blank">Launch simulator</a>
            <% end %>
            <% if @is_author %>
              <a href="#>" class="btn btn-secondary collaboratorButton" id="<%=@project.id%>" data-toggle="modal" data-target="#collaboratorModal">Add Collaborator</a>
            <%end %>



          </li>
          <%if !@project.description.nil? %>
              <li class="list-group-item"><b >Description: </b>
                <%= @project.description.html_safe %><br></li>
          <%end%>


        </ul>
        <div class="card-body">


        </div>

        <div class="card-footer text-center">
            <% if @user_access %>
                <%= link_to 'Edit', edit_user_project_path(@author, @project), class: "card-link"%>
                <% if @is_author  %>
                  <%= link_to 'Delete',user_project_path(@author,@project), method: :delete, data: { confirm: 'Are you sure?' }, class: "card-link" %>
                <% end %>
            <% end %>
          <%= link_to 'Fork', create_fork_project_path(@project), class: "card-link" %>
            <%= link_to 'Back', user_path(@author), class: "card-link" %>
          <% if @project.project_access_type != "Private" %>
            <a class="card-link" data-toggle="collapse" href="#collapseExample" aria-expanded="false" aria-controls="collapseExample" onclick="embed()" >
              Embed
            </a>
              <div class="collapse" id="collapseExample">
                <div class="card card-body">
                  <textarea id="embedTextArea" style="font-size:12px"><iframe width="600px" height="400px" src="<%=simulator_embed_url(@project)%>" id="projectPreview" scrolling="no" webkitAllowFullScreen mozAllowFullScreen allowFullScreen> </iframe></textarea>
                  <a class="text-success">Embed code copied to clipboard!</a>
                </div>
              </div>
          <%end%>


        </div>
      </div>



    </div>
  </div>

  <%  collaborators = @project.collaborators %>
  <% if collaborators.count !=0 %>
  <br>
  <h3>Collaborators</h3>
  <div style="max-height:400px;overflow:hidden;overflow-y:scroll" >
    <table class="table">
      <!--<thead>-->
      <!--<tr>-->
      <!--<th>Group members</th>-->
      <!--<th>Email IDs</th>-->
      <!--<th>Action</th>-->

      <!--</tr>-->
      <!--</thead>-->

      <tbody>

      <% @project.collaborators.each do |user| %>
          <tr>
            <td><%= link_to user.name, user %></td>
            <td><%= user.email %></td>
            <% if @is_author %>
                <td><%= link_to 'Remove', collaboration_path(Collaboration.find_by(user_id:user.id,project_id:@project.id)), method: :delete, data: { confirm: 'Are you sure?' } %></td>
            <% end %>
          </tr>
      <% end %>

      <tbody/>
      </table>

  </div>
  <% end %>




  <div id="collaboratorModal" class="modal fade" role="dialog">
    <div class="modal-dialog">

      <!-- Modal content-->
      <div class="modal-content">
        <div class="modal-header">
          <h4 class="modal-title">Add members</h4>
          <button type="button" class="close" data-dismiss="modal">&times;</button>

        </div>
        <div class="modal-body">
          <p>Enter Email IDs separated by commas. Users need to be registered already on the platform.
            Note that collaboration is not real time as of now. Every save overwites the previous data.</p>
          <%= form_with(model: @collaboration, local: true) do |form| %>
              <% if @collaboration.errors.any? %>
                  <div id="error_explanation">
                    <h2><%= pluralize(collaboration.errors.count, "error") %> prohibited this group_member from being saved:</h2>

                    <ul>
                      <% @collaborator.errors.full_messages.each do |message| %>
                          <li><%= message %></li>
                      <% end %>
                    </ul>
                  </div>
              <% end %>

              <div class="field">
                <%= form.hidden_field :project_id, id: :collaboration_project_id %>
              </div>

              <div class="form-group">
                <label for="Email Ids">Email IDs:</label>
                <textarea class="form-control" rows="5" id="emails" name="collaboration[emails]"></textarea>
              </div>

              <div class="actions modal-footer">
                <%= form.submit "Add Collaborators", class: 'btn btn-secondary' %>
              </div>
          <% end %>
        </div>
        <!--<div class="modal-footer">-->
        <!--<button type="button" class="btn btn-secondary" data-dismiss="modal">close</button>-->
        <!--</div>-->
      </div>

    </div>
  </div>


  <%= commontator_thread(@project) %>

</div>



  </p>

<div id="myModal" class="modal fade" role="dialog">
  <div class="modal-dialog modal-lg">

    <!-- Modal content-->
    <div class="modal-content">
      <div class="modal-header">
        <h4 class="modal-title">Project Preview</h4>
        <button type="button" class="close" data-dismiss="modal">&times;</button>

      </div>
      <div class="modal-body">
        <div class="embed-responsive embed-responsive-4by3 feature">
          <iframe src="" id="projectPreview" scrolling="no" webkitAllowFullScreen mozAllowFullScreen allowFullScreen> </iframe>
        </div>
      </div>
      <!--<div class="modal-footer">-->
      <!--<button type="button" class="btn btn-secondary" data-dismiss="modal">close</button>-->
      <!--</div>-->
    </div>

  </div>
</div>

<script>
    function embed() {
        setTimeout(function(){$("#embedTextArea").select();document.execCommand("copy")},100) ;

//        $("#embedTextArea").copy();
    }
    $( function() {
        $('.previewButton').on('click', function (e) {
            e.preventDefault()
            $("#projectPreview").attr("src","/simulator/" + e.currentTarget.id );
            $("#myModal").tab('show')
        })
        $('.collaboratorButton').on('click', function (e) {
            e.preventDefault()
            $("#collaboratorModel").tab('show')
        })
    } );
    function toggleStar(toggle) {
        $.ajax({
            url: "<%=change_stars_path(@project)%>",
            type: 'GET',
            beforeSend: function (xhr) {
                xhr.setRequestHeader('X-CSRF-Token', $('meta[name="csrf-token"]').attr('content'))
            },
            success: function (response) {
                star_count = document.getElementById("star_count").innerHTML;

                if(response == "1"){
                    document.getElementById('toggleStarButton').style.color='white';
                }
                else{
                    document.getElementById('toggleStarButton').style.color='orange';
                }
                document.getElementById("star_count").innerHTML = (response == "1") ? (Number(star_count)-1) : (Number(star_count)+1);
            }
        });
    }
</script>